## 4b8800252a378b12836b97af2c625fe0426e03fb

=== src/os/CMakeLists.txt ===
set(libos_srcs
  ObjectStore.cc
  Transaction.cc
  filestore/chain_xattr.cc
  filestore/BtrfsFileStoreBackend.cc
  filestore/DBObjectMap.cc
  filestore/FileJournal.cc
  filestore/FileStore.cc
  filestore/JournalThrottle.cc
  filestore/GenericFileStoreBackend.cc
  filestore/JournalingObjectStore.cc
  filestore/HashIndex.cc
  filestore/IndexManager.cc
  filestore/LFNIndex.cc
  filestore/WBThrottle.cc
  filestore/os_xattr.c
  memstore/MemStore.cc
  kstore/KStore.cc
  kstore/kstore_types.cc
  fs/FS.cc)

if(WITH_BLUESTORE)
  list(APPEND libos_srcs
    bluestore/Allocator.cc
    bluestore/BitmapFreelistManager.cc
    bluestore/BlueFS.cc
    bluestore/bluefs_types.cc
    bluestore/BlueRocksEnv.cc
    bluestore/BlueStore.cc
    bluestore/bluestore_types.cc
    bluestore/fastbmap_allocator_impl.cc
    bluestore/FreelistManager.cc
    bluestore/StupidAllocator.cc
    bluestore/BitmapAllocator.cc
    bluestore/AvlAllocator.cc
    bluestore/HybridAllocator.cc
  )
endif(WITH_BLUESTORE)

if(WITH_ZBD)
  list(APPEND libos_srcs
    bluestore/zoned_types.cc
    bluestore/ZonedFreelistManager.cc
    bluestore/ZonedAllocator.cc)
endif()

if(WITH_FUSE)
  list(APPEND libos_srcs
    FuseStore.cc)
endif(WITH_FUSE)

if(HAVE_LIBXFS)
  list(APPEND libos_srcs
    filestore/XfsFileStoreBackend.cc
    fs/XFS.cc)
endif()

if(HAVE_LIBZFS)
  add_library(os_zfs_objs OBJECT
    filestore/ZFSFileStoreBackend.cc
    fs/ZFS.cc)
  target_include_directories(os_zfs_objs SYSTEM PRIVATE
    ${ZFS_INCLUDE_DIRS})
  list(APPEND libos_srcs $<TARGET_OBJECTS:os_zfs_objs>)
endif()

add_library(os STATIC ${libos_srcs})
target_link_libraries(os blk)

target_link_libraries(os heap_profiler kv)

if(WITH_BLUEFS)
  add_library(bluefs SHARED 
    bluestore/BlueRocksEnv.cc)
  target_include_directories(bluefs SYSTEM PUBLIC
    $<TARGET_PROPERTY:RocksDB::RocksDB,INTERFACE_INCLUDE_DIRECTORIES>)
  target_link_libraries(bluefs global)
  install(TARGETS bluefs DESTINATION lib)
endif(WITH_BLUEFS)

if(WITH_FUSE)
  target_link_libraries(os FUSE::FUSE)
endif()

if(HAVE_LIBZFS)
  target_link_libraries(os ${ZFS_LIBRARIES})
endif()

if(WITH_LTTNG)
  add_dependencies(os objectstore-tp)
  add_dependencies(os bluestore-tp)
endif()

if(WITH_JAEGER)
  target_link_libraries(os jaeger-base)
endif()

target_link_libraries(os kv)

add_dependencies(os compressor_plugins)
add_dependencies(os crypto_plugins)


if(WITH_BLUESTORE)
  add_executable(ceph-bluestore-tool
    bluestore/bluestore_tool.cc)
  target_link_libraries(ceph-bluestore-tool
    os global)
  install(TARGETS ceph-bluestore-tool
    DESTINATION bin)
endif()

=== qa/workunits/direct_io/Makefile ===
CFLAGS = -Wall -Wextra -D_GNU_SOURCE

TARGETS = direct_io_test test_sync_io test_short_dio_read

.c:
	$(CC) $(CFLAGS) $@.c -o $@

all:	$(TARGETS)

clean:
	rm $(TARGETS)

=== src/jaegertracing/thrift/compiler/cpp/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements. See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership. The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied. See the License for the
# specific language governing permissions and limitations
# under the License.
#

cmake_minimum_required(VERSION 3.3)
project("thrift-compiler" VERSION ${PACKAGE_VERSION})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/thrift/version.h)

find_package(FLEX REQUIRED)
find_package(BISON REQUIRED)

# create directory for thrifty and thriftl
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/thrift/)

# Create flex and bison files and build the lib parse static library
BISON_TARGET(thrifty ${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/thrifty.yy ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc)
FLEX_TARGET(thriftl ${CMAKE_CURRENT_SOURCE_DIR}/src/thrift/thriftl.ll ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc)
ADD_FLEX_BISON_DEPENDENCY(thriftl thrifty)

set(parse_SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thriftl.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/thrifty.hh
)

add_library(parse STATIC ${parse_SOURCES})

# Create the thrift compiler
set(compiler_core
    src/thrift/common.cc
    src/thrift/generate/t_generator.cc
    src/thrift/parse/t_typedef.cc
    src/thrift/parse/parse.cc
    ${CMAKE_CURRENT_BINARY_DIR}/thrift/version.h
)

set(thrift-compiler_SOURCES
    src/thrift/main.cc
    src/thrift/audit/t_audit.cpp
)

set(thrift_compiler_LANGS
)

# This macro adds an option THRIFT_COMPILER_${NAME}
# that allows enabling or disabling certain languages
macro(THRIFT_ADD_COMPILER name description initial)
    string(TOUPPER "THRIFT_COMPILER_${name}" enabler)
    set(src "src/thrift/generate/t_${name}_generator.cc")
    option(${enabler} ${description} ${initial})
    if(${enabler})
        list(APPEND thrift-compiler_SOURCES ${src})
        list(APPEND thrift_compiler_LANGS ${name})
    endif()
endmacro()

# The following compiler can be enabled or disabled
THRIFT_ADD_COMPILER(as3     "Enable compiler for ActionScript 3" ON)
THRIFT_ADD_COMPILER(c_glib  "Enable compiler for C with Glib" ON)
THRIFT_ADD_COMPILER(cl      "Enable compiler for Common LISP" ON)
THRIFT_ADD_COMPILER(cpp     "Enable compiler for C++" ON)
THRIFT_ADD_COMPILER(csharp  "Enable compiler for C#" ON)
THRIFT_ADD_COMPILER(d       "Enable compiler for D" ON)
THRIFT_ADD_COMPILER(dart    "Enable compiler for Dart" ON)
THRIFT_ADD_COMPILER(delphi  "Enable compiler for Delphi" ON)
THRIFT_ADD_COMPILER(erl     "Enable compiler for Erlang" ON)
THRIFT_ADD_COMPILER(go      "Enable compiler for Go" ON)
THRIFT_ADD_COMPILER(gv      "Enable compiler for GraphViz" ON)
THRIFT_ADD_COMPILER(haxe    "Enable compiler for Haxe" ON)
THRIFT_ADD_COMPILER(hs      "Enable compiler for Haskell" ON)
THRIFT_ADD_COMPILER(html    "Enable compiler for HTML Documentation" ON)
THRIFT_ADD_COMPILER(java    "Enable compiler for Java"   ON)
THRIFT_ADD_COMPILER(javame  "Enable compiler for Java ME" ON)
THRIFT_ADD_COMPILER(js      "Enable compiler for JavaScript" ON)
THRIFT_ADD_COMPILER(json    "Enable compiler for JSON" ON)
THRIFT_ADD_COMPILER(lua     "Enable compiler for Lua" ON)
THRIFT_ADD_COMPILER(netcore "Enable compiler for .NET Core" ON)
THRIFT_ADD_COMPILER(netstd  "Enable compiler for .NET Standard" ON)
THRIFT_ADD_COMPILER(ocaml   "Enable compiler for OCaml" ON)
THRIFT_ADD_COMPILER(perl    "Enable compiler for Perl" ON)
THRIFT_ADD_COMPILER(php     "Enable compiler for PHP" ON)
THRIFT_ADD_COMPILER(py      "Enable compiler for Python 2.0" ON)
THRIFT_ADD_COMPILER(rb      "Enable compiler for Ruby" ON)
THRIFT_ADD_COMPILER(rs      "Enable compiler for Rust" ON)
THRIFT_ADD_COMPILER(st      "Enable compiler for Smalltalk" ON)
THRIFT_ADD_COMPILER(swift   "Enable compiler for Cocoa Swift" ON)
THRIFT_ADD_COMPILER(xml     "Enable compiler for XML" ON)
THRIFT_ADD_COMPILER(xsd     "Enable compiler for XSD" ON)

# Thrift is looking for include files in the src directory
# we also add the current binary directory for generated files
include_directories(${CMAKE_CURRENT_BINARY_DIR} src)

list(APPEND thrift-compiler_SOURCES ${compiler_core})

add_executable(thrift-compiler ${thrift-compiler_SOURCES})

set_target_properties(thrift-compiler PROPERTIES RUNTIME_OUTPUT_DIRECTORY bin/)
set_target_properties(thrift-compiler PROPERTIES OUTPUT_NAME thrift)

target_link_libraries(thrift-compiler parse)

install(TARGETS thrift-compiler DESTINATION bin)

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== src/spdk/dpdk/lib/librte_gso/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2017 Intel Corporation

include $(RTE_SDK)/mk/rte.vars.mk

# library name
LIB = librte_gso.a

CFLAGS += $(WERROR_FLAGS) -I$(SRCDIR) -O3
LDLIBS += -lrte_eal -lrte_mbuf -lrte_ethdev -lrte_net
LDLIBS += -lrte_mempool

EXPORT_MAP := rte_gso_version.map

#source files
SRCS-$(CONFIG_RTE_LIBRTE_GSO) += rte_gso.c
SRCS-$(CONFIG_RTE_LIBRTE_GSO) += gso_common.c
SRCS-$(CONFIG_RTE_LIBRTE_GSO) += gso_tcp4.c
SRCS-$(CONFIG_RTE_LIBRTE_GSO) += gso_tunnel_tcp4.c
SRCS-$(CONFIG_RTE_LIBRTE_GSO) += gso_udp4.c

# install this header file
SYMLINK-$(CONFIG_RTE_LIBRTE_GSO)-include += rte_gso.h

include $(RTE_SDK)/mk/rte.lib.mk

=== src/spdk/dpdk/lib/librte_telemetry/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2018 Intel Corporation

include $(RTE_SDK)/mk/rte.vars.mk

# library name
LIB = librte_telemetry.a

ARCH_DIR ?= $(RTE_ARCH)

CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS) -I$(SRCDIR)
CFLAGS += -I$(RTE_SDK)/lib/librte_metrics/
CFLAGS += -I$(RTE_SDK)/lib/librte_eal/include
CFLAGS += -I$(RTE_SDK)/lib/librte_eal/$(ARCH_DIR)/include
CFLAGS += -pthread

LDLIBS += -lpthread

EXPORT_MAP := rte_telemetry_version.map

# library source files
SRCS-y += telemetry.c
SRCS-y += telemetry_data.c
SRCS-y += telemetry_legacy.c

# export include files
SYMLINK-y-include := rte_telemetry.h

include $(RTE_SDK)/mk/rte.lib.mk

=== src/spdk/examples/ioat/perf/Makefile ===
#
#  BSD LICENSE
#
#  Copyright (c) Intel Corporation.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
#    * Neither the name of Intel Corporation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SPDK_ROOT_DIR := $(abspath $(CURDIR)/../../..)
include $(SPDK_ROOT_DIR)/mk/spdk.common.mk

APP = ioat_perf

C_SRCS := perf.c

SPDK_LIB_LIST = ioat thread util log

include $(SPDK_ROOT_DIR)/mk/spdk.app.mk

=== src/seastar/dpdk/drivers/compress/zlib/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2018 Cavium Networks

include $(RTE_SDK)/mk/rte.vars.mk

# library name
LIB = librte_pmd_zlib.a

# build flags
CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)
CFLAGS += -DALLOW_EXPERIMENTAL_API

# library version
LIBABIVER := 1

# versioning export map
EXPORT_MAP := rte_pmd_zlib_version.map

# external library dependencies
LDLIBS += -lrte_eal -lrte_mbuf -lrte_mempool -lrte_ring -lz
LDLIBS += -lrte_compressdev
LDLIBS += -lrte_bus_vdev

# library source files
SRCS-$(CONFIG_RTE_LIBRTE_PMD_ZLIB) += zlib_pmd.c
SRCS-$(CONFIG_RTE_LIBRTE_PMD_ZLIB) += zlib_pmd_ops.c

include $(RTE_SDK)/mk/rte.lib.mk

=== src/seastar/dpdk/drivers/net/af_packet/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2014 John W. Linville <linville@redhat.com>
# Copyright(c) 2010-2014 Intel Corporation.
# Copyright(c) 2014 6WIND S.A.
# All rights reserved.

include $(RTE_SDK)/mk/rte.vars.mk

#
# library name
#
LIB = librte_pmd_af_packet.a

EXPORT_MAP := rte_pmd_af_packet_version.map

LIBABIVER := 1

CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)
LDLIBS += -lrte_eal -lrte_mbuf -lrte_mempool -lrte_ring
LDLIBS += -lrte_ethdev -lrte_net -lrte_kvargs
LDLIBS += -lrte_bus_vdev

#
# all source are stored in SRCS-y
#
SRCS-$(CONFIG_RTE_LIBRTE_PMD_AF_PACKET) += rte_eth_af_packet.c

include $(RTE_SDK)/mk/rte.lib.mk

=== src/seastar/dpdk/drivers/net/mlx4/Makefile ===
#   SPDX-License-Identifier: BSD-3-Clause
#   Copyright 2012 6WIND S.A.
#   Copyright 2012 Mellanox Technologies, Ltd

include $(RTE_SDK)/mk/rte.vars.mk

# Library name.
LIB = librte_pmd_mlx4.a
LIB_GLUE = $(LIB_GLUE_BASE).$(LIB_GLUE_VERSION)
LIB_GLUE_BASE = librte_pmd_mlx4_glue.so
LIB_GLUE_VERSION = 18.02.0

# Sources.
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_ethdev.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_flow.c
ifneq ($(CONFIG_RTE_IBVERBS_LINK_DLOPEN),y)
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_glue.c
endif
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_intr.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_mp.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_mr.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_rxq.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_rxtx.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_txq.c
SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD) += mlx4_utils.c

ifeq ($(CONFIG_RTE_IBVERBS_LINK_DLOPEN),y)
INSTALL-$(CONFIG_RTE_LIBRTE_MLX4_PMD)-lib += $(LIB_GLUE)
endif

# Basic CFLAGS.
CFLAGS += -O3
CFLAGS += -std=c11 -Wall -Wextra
CFLAGS += -g
CFLAGS += -I.
CFLAGS += -D_BSD_SOURCE
CFLAGS += -D_DEFAULT_SOURCE
CFLAGS += -D_XOPEN_SOURCE=600
CFLAGS += $(WERROR_FLAGS)
CFLAGS += -DALLOW_EXPERIMENTAL_API
ifeq ($(CONFIG_RTE_IBVERBS_LINK_DLOPEN),y)
CFLAGS += -DMLX4_GLUE='"$(LIB_GLUE)"'
CFLAGS += -DMLX4_GLUE_VERSION='"$(LIB_GLUE_VERSION)"'
CFLAGS_mlx4_glue.o += -fPIC
LDLIBS += -ldl
else ifeq ($(CONFIG_RTE_IBVERBS_LINK_STATIC),y)
LDLIBS += $(shell $(RTE_SDK)/buildtools/options-ibverbs-static.sh)
else
LDLIBS += -libverbs -lmlx4
endif
LDLIBS += -lrte_eal -lrte_mbuf -lrte_mempool -lrte_ring
LDLIBS += -lrte_ethdev -lrte_net -lrte_kvargs
LDLIBS += -lrte_bus_pci

# A few warnings cannot be avoided in external headers.
CFLAGS += -Wno-error=cast-qual

EXPORT_MAP := rte_pmd_mlx4_version.map
LIBABIVER := 1

# DEBUG which is usually provided on the command-line may enable
# CONFIG_RTE_LIBRTE_MLX4_DEBUG.
ifeq ($(DEBUG),1)
CONFIG_RTE_LIBRTE_MLX4_DEBUG := y
endif

# User-defined CFLAGS.
ifeq ($(CONFIG_RTE_LIBRTE_MLX4_DEBUG),y)
CFLAGS += -pedantic -UNDEBUG -DPEDANTIC
else
CFLAGS += -DNDEBUG -UPEDANTIC
endif

include $(RTE_SDK)/mk/rte.lib.mk

# Generate and clean-up mlx4_autoconf.h.

export CC CFLAGS CPPFLAGS EXTRA_CFLAGS EXTRA_CPPFLAGS
export AUTO_CONFIG_CFLAGS = -Wno-error

ifndef V
AUTOCONF_OUTPUT := >/dev/null
endif

mlx4_autoconf.h.new: FORCE

mlx4_autoconf.h.new: $(RTE_SDK)/buildtools/auto-config-h.sh
	$Q $(RM) -f -- '$@'
	$Q : > '$@'
	$Q sh -- '$<' '$@' \
		HAVE_IBV_MLX4_BUF_ALLOCATORS \
		infiniband/mlx4dv.h \
		enum MLX4DV_SET_CTX_ATTR_BUF_ALLOCATORS \
		$(AUTOCONF_OUTPUT)
	$Q sh -- '$<' '$@' \
		HAVE_IBV_MLX4_UAR_MMAP_OFFSET \
		infiniband/mlx4dv.h \
		enum MLX4DV_QP_MASK_UAR_MMAP_OFFSET \
		$(AUTOCONF_OUTPUT)
	$Q sh -- '$<' '$@' \
		HAVE_IBV_MLX4_WQE_LSO_SEG \
		infiniband/mlx4dv.h \
		type 'struct mlx4_wqe_lso_seg' \
		$(AUTOCONF_OUTPUT)

# Create mlx4_autoconf.h or update it in case it differs from the new one.

mlx4_autoconf.h: mlx4_autoconf.h.new
	$Q [ -f '$@' ] && \
		cmp '$<' '$@' $(AUTOCONF_OUTPUT) || \
		mv '$<' '$@'

$(SRCS-$(CONFIG_RTE_LIBRTE_MLX4_PMD):.c=.o): mlx4_autoconf.h

# Generate dependency plug-in for rdma-core when the PMD must not be linked
# directly, so that applications do not inherit this dependency.

ifeq ($(CONFIG_RTE_IBVERBS_LINK_DLOPEN),y)

$(LIB): $(LIB_GLUE)

ifeq ($(LINK_USING_CC),1)
GLUE_LDFLAGS := $(call linkerprefix,$(LDFLAGS))
else
GLUE_LDFLAGS := $(LDFLAGS)
endif
$(LIB_GLUE): mlx4_glue.o
	$Q $(LD) $(GLUE_LDFLAGS) $(EXTRA_LDFLAGS) \
		-Wl,-h,$(LIB_GLUE) \
		-shared -o $@ $< -libverbs -lmlx4

mlx4_glue.o: mlx4_autoconf.h

endif

clean_mlx4: FORCE
	$Q rm -f -- mlx4_autoconf.h mlx4_autoconf.h.new
	$Q rm -f -- mlx4_glue.o $(LIB_GLUE_BASE)*

clean: clean_mlx4

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Homepage: http://ceph.com/
Vcs-Git: git://github.com/ceph/ceph.git
Vcs-Browser: https://github.com/ceph/ceph
Maintainer: Ceph Maintainers <ceph-maintainers@lists.ceph.com>
Uploaders: Ken Dreyer <kdreyer@redhat.com>,
           Alfredo Deza <adeza@redhat.com>,
Build-Depends: automake,
# Jaeger       bison,
               cmake (>= 3.10.2),
               cpio,
               cryptsetup-bin | cryptsetup,
               cython3,
               debhelper (>= 10),
               default-jdk,
               dh-exec,
               dh-python,
# Jaeger       flex,
               git,
               golang,
               gperf,
               g++ (>= 7),
               javahelper,
               jq <pkg.ceph.check>,
               jsonnet <pkg.ceph.check>,
               junit4,
               libaio-dev,
               libbabeltrace-ctf-dev,
               libbabeltrace-dev,
               libblkid-dev (>= 2.17),
# Crimson      libc-ares-dev,
# Crimson      libcrypto++-dev,
               libcryptsetup-dev,
               libcap-ng-dev,
               libcunit1-dev,
               libcurl4-openssl-dev,
# Jaeger       libevent-dev,
               libexpat1-dev,
               libffi-dev [!amd64] <pkg.ceph.check>,
               libfuse-dev,
               libgoogle-perftools-dev [i386 amd64 arm64],
# Crimson      libgnutls28-dev,
# Crimson      libhwloc-dev,
               libibverbs-dev,
               libicu-dev,
               librdmacm-dev,
               libkeyutils-dev,
               libldap2-dev,
               libleveldb-dev,
               liblttng-ust-dev,
               liblua5.3-dev,
               liblz4-dev (>= 0.0~r131),
               libncurses-dev,
               libnss3-dev,
               liboath-dev,
# Crimson      libnuma-dev,
# Crimson      libpciaccess-dev,
# Crimson      libprotobuf-dev,
# Crimson      libsctp-dev,
               libsnappy-dev,
               libsqlite3-dev,
               libssl-dev,
               libtool,
               libudev-dev,
               libnl-genl-3-dev,
               libxml2-dev,
               librabbitmq-dev,
               librdkafka-dev,
               luarocks,
               libxmlsec1 <pkg.ceph.check>,
               libxmlsec1-nss <pkg.ceph.check>,
               libxmlsec1-openssl <pkg.ceph.check>,
               libxmlsec1-dev <pkg.ceph.check>,
# Crimson      libyaml-cpp-dev,
# Jaeger       nlohmann-json-dev | nlohmann-json3-dev,
               parted,
               patch,
               pkg-config,
               prometheus <pkg.ceph.check>,
# Crimson      protobuf-compiler,
               python3-all-dev,
               python3-cherrypy3,
               python3-jwt <pkg.ceph.check>,
               python3-pecan <pkg.ceph.check>,
               python3-bcrypt <pkg.ceph.check>,
               tox <pkg.ceph.check>,
               python3-coverage <pkg.ceph.check>,
               python3-dateutil <pkg.ceph.check>,
               python3-pkg-resources <pkg.ceph.check>,
               python3-openssl <pkg.ceph.check>,
               python3-prettytable <pkg.ceph.check>,
               python3-requests <pkg.ceph.check>,
               python3-scipy <pkg.ceph.check>,
               python3-setuptools,
               python3-sphinx,
               python3-werkzeug <pkg.ceph.check>,
               python3-setuptools,
               python3-venv,
# Crimson      ragel,
               socat <pkg.ceph.check>,
# Crimson      systemtap-sdt-dev,
               uuid-dev <pkg.ceph.check>,
               uuid-runtime,
               valgrind,
               xfslibs-dev,
               xfsprogs <pkg.ceph.check>,
               xmlstarlet <pkg.ceph.check>,
               nasm [amd64],
               zlib1g-dev,
# Jaeger       Built-Using:   libyaml-cpp-dev (>= 0.6),
Standards-Version: 4.4.0

Package: ceph
Architecture: linux-any
Depends: ceph-mgr (= ${binary:Version}),
         ceph-mon (= ${binary:Version}),
         ceph-osd (= ${binary:Version}),
Recommends: ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: linux-any
Depends: binutils,
         ceph-common (= ${binary:Version}),
         cryptsetup-bin | cryptsetup,
         debianutils,
         e2fsprogs,
         findutils,
         grep,
         logrotate,
         parted,
         psmisc,
         xfsprogs,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Recommends: btrfs-tools,
            ceph-mds (= ${binary:Version}),
            librados2 (= ${binary:Version}),
            libradosstriper1 (= ${binary:Version}),
            librbd1 (= ${binary:Version}),
            ntp | time-daemon,
            nvme-cli,
            smartmontools,
Replaces: ceph (<< 10),
          ceph-common (<< 0.78-500),
          ceph-test (<< 12.2.2-14),
          python-ceph (<< 0.92-1223),
Breaks: ceph (<< 10),
        ceph-test (<< 12.2.2-14),
        python-ceph (<< 0.92-1223),
Description: common ceph daemon libraries and management tools
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-base-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-base
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.
 .
 This package contains the debugging symbols for ceph-base.

Package: cephadm
Architecture: linux-any
Recommends: podman (>= 2.0.2) | docker.io
Depends: lvm2,
	 ${python:Depends},
Description: cephadm utility to bootstrap ceph daemons with systemd and containers
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 The cephadm utility is used to bootstrap a Ceph cluster and to manage
 ceph daemons deployed with systemd and containers.

Package: ceph-mds
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ceph-fuse (= ${binary:Version}),
            libcephfs2 (= ${binary:Version}),
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: metadata server for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mds-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-mds (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-mds
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the debugging symbols for ceph-mds.

Package: ceph-mgr
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ceph-mgr-modules-core (= ${binary:Version}),
         python3-bcrypt,
         python3-cherrypy3,
         python3-distutils,
         python3-jwt,
         python3-openssl,
         python3-pecan,
         python3-requests,
         python3-werkzeug,
         libsqlite3-mod-ceph (= ${binary:Version}),
         librados2 (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Recommends: ceph-mgr-dashboard,
            ceph-mgr-diskprediction-local,
            ceph-mgr-k8sevents,
            ceph-mgr-cephadm
Suggests: python3-influxdb
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: manager for the ceph distributed storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-dashboard
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-cherrypy3,
         python3-jwt,
         python3-bcrypt,
         python3-pkg-resources,
         python3-werkzeug,
         python3-routes,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: dashboard module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr module, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-numpy,
         python3-scipy,
         python3-sklearn,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: diskprediction-local module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local module for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-modules-core
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python3-dateutil,
         python3-openssl,
Replaces: ceph-mgr (<< 15.1.0)
Breaks: ceph-mgr (<< 15.1.0)
Description: ceph manager modules which are always enabled
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains a set of core ceph-mgr modules which are always
 enabled.

Package: ceph-mgr-rook
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-jsonpatch
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: rook module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.

Package: ceph-mgr-k8sevents
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-kubernetes,
         ${misc:Depends},
         ${python:Depends},
Description: kubernetes events module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents module, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.

Package: ceph-mgr-cephadm
Architecture: all
